ADN Open CIS
Сообщество программистов Autodesk в СНГ

27/10/2015

Редактирование связанного файла

Вопрос: В своем коде я пытаюсь создать пространство внутри связанной модели. Но, получаю ошибку при вызове метода NewSpace:

 

Хотя я вызываю метод внутри транзакции главного документа и поэтому не пойму, почему появляется ошибка.

Опубликовано 27.10.2015     Читать далее >>>
27/10/2015

Преобразование координат листа в координаты модели

Вопрос: Вы отмечали, что в Revit API есть пробел, связанный с конвертацией между координатами модели и координатами листа. Это как раз то, с чем мы столкнулись.

Нам нужно получить границы геометрии элемента на листе.

В Revit 2016 этот пробел все еще существует? Есть ли какой-то способ обойти это ограничение?

Опубликовано 27.10.2015     Читать далее >>>
01/10/2015

Создание семейства в памяти

Вопрос: Когда создается новое семейство, то ему автоматически присваивается имя, которое можно увидеть в заголовке. Возможно ли изменить это имя и заголовок без сохранения файла? Я не хочу сохранять фал. Я просто хочу загрузить его сразу в другую модель.

 

Опубликовано 01.10.2015     Читать далее >>>
30/09/2015

Объединение геометрии стен и колонн

Я пытался найти в блоге пример использования объединения геометрии, но так и не смог. Собственно, вот он.

Опубликовано 30.09.2015     Читать далее >>>
30/09/2015

Перечисление элементов

Очень много людей используют FilteredElementCollector, например, вот так:

Код - C#: [Выделить]
  FilteredElementCollector collector

    = new FilteredElementCollector( doc );

 

  collector.OfClass( typeof( Family ) ).ToElements();

 

  IEnumerable<Family> nestedFamilies

    = collector.ToElements().Cast<Family>();

 

  String str = "";

 

  foreach( Family f in nestedFamilies )

  {

    str = str + f.Name + "\n";

 

    foreach( ElementId symbolId in

      f.GetFamilySymbolIds() )

    {

      Element symbolElem = doc.GetElement(

        symbolId );

 

      str = str + " типоразмер: "

        + symbolElem.Name + "\n";

    }

  }

Опубликовано 30.09.2015     Читать далее >>>
30/09/2015

Создание крыши

Изначально вопрос бы задан на форуме Revit API и Stack Overflow:

Вопрос: У меня проблема с программным созданием крыши. Я знаю, как создавать лестницы, к примеру, используя CreateSketchedLanding с корректными параметрами. Но вот как воздать крышу с нуля, не пойму. Может кто-нибудь направить меня в нужное русло?

Опубликовано 30.09.2015     Читать далее >>>
27/09/2015

Чтение общей площади зоны здания и площади офисных зон

Небольшой пример того, как читать площадь зон, являющихся общей площадью здания и офисной зоной. Начнем с получение объектов класса Area (зона), используя FilteredElementCollector и фильтр SpatialElement. Затем, AreaScheme и, если требуется, ограничим по уровню, на котором располагается зона. В итоге отобразим общую площадь зон по зданию и площадь офисных зон.

Опубликовано 27.09.2015     Читать далее >>>
27/09/2015

Закрытие активного документа

На форуме один из пользователей говорит, что он хочет закрыть активный документ и заново его открыть.

Опубликовано 27.09.2015     Читать далее >>>
27/09/2015

О геометрии в Revit и грани цилиндров

Вопрос: При обходе по граням, представляющим границы цилиндра, я обнаружил, что цилиндр имеет 2 плоских грани (верх и низ цилиндра) и две цилиндрических грани (два полуцилиндра). Я проверил еще несколько различных закругленных поверхностей в Revit и заметил, что все они поделены на 2 или 4 полу- или четверть-цилиндра. Почему так?

Опубликовано 27.09.2015     Читать далее >>>
22/09/2015

Отмена ограничений для VendorId

Опубликовано 22.09.2015     Читать далее >>>
31/08/2015

Получить элементы сборки

Вопрос: Как получить все элементы, являющиеся частью сборки?

Ответ: Как вы уже наверно попробовали, RevitLookup не отображает какой-либо полезной информации о выбранной сборки.

Опубликовано 31.08.2015     Читать далее >>>
31/08/2015

Создание поверхности в Revit

Вопрос: Мне нужно создать поверхность с помощью Revit API по заданным точкам. Поверхность может быть любая, например, пол, крыша или любой другой компонент. Поверхность не является рабочей плоскостью.

Опубликовано 31.08.2015     Читать далее >>>
31/08/2015

Сводная информация о контексте Revit API

Вопрос: Не разрешается запустить новую транзакцию при вызове из внешнего приложения и запущенного вне контекста Revit API. Как быть?

Опубликовано 31.08.2015     Читать далее >>>
31/08/2015

Реагирование на двойной щелчок мыши в Revit

Вопрос: Я подумываю о том, чтобы задать поведение при двойном нажатии на мышку или на правую кнопку мыши, например, когда выделена лампа или другой объект.

 

Есть ли в Revit API соответствующие методы, для реализации задуманного?

Опубликовано 31.08.2015     Читать далее >>>
29/08/2015

InvalidOperationException при использовании метода FamilyManager.Set

Вопрос: Не могли бы вы подтвердить, что действительно невозможно установить значение параметра семейства, если не задан активный типоразмер?

 

Опубликовано 29.08.2015     Читать далее >>>
29/08/2015

Проблема при использовании ElementIntersectsSolidFilter

Вопрос: У меня проблема с использованием ElementIntersectsSolidFilter. Результат получается совсем не тот, который я ожидаю увидеть.

Мне нужно определить, лежит ли заданная точка на любой части стены и получить список таких стен. Допустимая погрешность – 100 мм. Т.е. если точка находится на расстоянии 100 мм от стены, считаем, что точка лежит на стене.

Опубликовано 29.08.2015     Читать далее >>>
28/08/2015

Использование ReferenceIntersector со связанными файлами

Вопрос: Согласно документации к API, а также предварительного тестирования, ReferenceIntersector не находит пересечения с элементами в связанных файлах в Revit 2015.

Например, мы не сможем найти, что кабельный канал пересекает стену.

Опубликовано 28.08.2015     Читать далее >>>
25/08/2015

Доступ к IfcGUID импортированной стены

Вопрос: У меня есть стена, которая в IFC файле задана с идентификатором ‘3lDzp1LFjDqwXDAihsyNrA’ и выглядит примерно так:

Код: [Выделить]
  #615 = IFCWALLSTANDARDCASE( '3lDzp1LFjDqwXDAihsyNrA',

    #42, '\X2\6A196E9658C1\X0\:(P)PC200:1185289', $,

    '\X2\6A196E9658C1\X0\:(P)PC200:794115',

    #587, #613, '1185289' );

Как можно получить IFC GUID '3lDzp1LFjDqwXDAihsyNrA' для этой стены в модели Revit?

Опубликовано 25.08.2015     Читать далее >>>
29/07/2015

Чтение доступных методов определения потерь

Недавно мы рассматривали, как можно получить данные таблицы ASHRE. Эта информация хранится в Расширяемой области хранения и связана с элементом параметром  RBS_DUCT_FITTING_LOSS_METHOD_SERVER_PARAM в виде GUID значения.

А как мы можем получить список всех доступных методов определения потерь?

 

Опубликовано 29.07.2015     Читать далее >>>
21/07/2015

Исключение при вызове метода NewExtrusion - один из параметров не удовлетворяет требованиям

Иногда, при вызове метода Document.FamilyCreate.NewExtrusion возникает исключение:  Autodesk.Revit.Exceptions.ArgumentException - один из параметров не удовлетворяет требованиям.

Опубликовано 21.07.2015     Читать далее >>>